<?php
error_reporting(E_ALL ^ E_NOTICE);

if (!$in_site) {

	include_once("conf.php");
	include_once("functions.php");

	/*** Language File ***/
  	$lang_file = "lang/$use_lang/share.lang.php";
  	if (file_exists($lang_file)) {
    	include($lang_file);
  	} else {
    	$output = error(array("Language file $lang_file not found"));
    	exit($output);  
  	}
}

$action = $_REQUEST["action"];

//share via email
if ($action == "send") {
  $sharec = trim($_REQUEST["sc"]);
  $mailto = trim($_REQUEST["mailto"]);
  $mailfrom = trim($_REQUEST["mailfrom"]);
  $message = trim($_REQUEST["message"]);
  if (!$message) $message = "- n/a -";
  
  if (!$mailto) $error[] = lang("error_nomailto");
  elseif (!is_email($mailto)) $error[] = lang("error_wrongmailto");
  if (!$mailfrom) $error[] = lang("error_nomailfrom");
  elseif (!is_email($mailfrom)) $error[] = lang("error_wrongmailfrom");
  
  if ($error) $mailStat = error($error);
  else {
    $official_sharec = sharecode(sharecode($sharec,"decode",true));
    mail($mailto,sprintf(lang("mail_share_subject"),$mailfrom, $site_name), 
                 sprintf(lang("mail_share_body"),$mailto,$mailfrom,"$url/" . ($mod_rewrite ? "S" . $official_sharec . "S30" : "shared.php?sc=$official_sharec&s=30"),$message,$url,$site_name),"From: $mailfrom");
    $mailStat = success(lang("success_message_sent"));
  }
  if (!$in_site) echo $mailStat;
}

//description update
if ($action == "update_descr") {
	$sharec = trim($_REQUEST["sc"]);
	$descr = trim($_REQUEST["descr"]);

	$id = sharecode($sharec,"decode",true);

	$file = $upload_dir_prefix . "share/$id/descr.txt";
	$handle = fopen($file, "w");
	fwrite($handle, $descr);
	fclose($handle);
	$descrStat = success(lang("success_descr_update"));
	if (!$in_site) echo $descrStat;
}

//image Rotation
if ($action == "flipImg") {
  $sc = trim($_REQUEST["sc"]);
  $dir = trim($_REQUEST["dir"]);//direction
  $id = sharecode($sc,"decode",true);
  if (!$id) $error = "1" . $sc . lang("error_imgnotfound");
  elseif (!is_dir($upload_dir_prefix . "share/$id")) $error ="2" .  lang("error_imgnotfound");
  else {
    //filename check
    $d = opendir($upload_dir_prefix . "share/$id/s3");
    while(false !== ($file = readdir($d))){
       if ($file == "." || $file == "..") continue;
       else {
        $img = $file;
        break;
      }
    }
    closedir($d);
    if (!$img) $error ="3" .  lang("error_imgnotfound");
  }
  if (!$error) {
    //everything found, let's go :)

    $filename = $upload_dir_prefix . "share/$id/s3/$img";
    $degrees = ($dir == "ccw" ? 90 : 270);
    $ext = explode(".",$img);
    $ext = strtolower(array_pop($ext));
    if ($ext == "gif") $source = imagecreatefromgif($filename);
    elseif ($ext == "png") $source = imagecreatefrompng($filename);
    else $source = imagecreatefromjpeg($filename);

    // Rotate
    $rotate = image_rotate($source, $degrees);
    // Output to temppic
    imagejpeg($rotate,$filename . ".rot");
    unlink($filename);
    rename($filename.".rot",preg_replace("/\.$ext$/",".jpg",$filename));
    // delete the other sizes
    if (is_dir($upload_dir_prefix . "share/$id")){
      $deld=opendir($upload_dir_prefix . "share/$id");
      while(false !== ($file = readdir($deld))){
         if (in_array($file, array(".","..","s3","descr.txt"))) continue;
         xrmdir($upload_dir_prefix . "share/$id/$file");
      }
      closedir($deld);
      unset($deld);
      $success = "OK" . ($mod_rewrite?"SEO":"");
    }
  }
  if (!$in_site) echo ($error?$error:$success);
}

//SIS Admin Functions
if ($_SESSION["sis_auth"]) {
  //delete images
  if ($action == "delete") {
    $sc = trim($_REQUEST["sc"]);
    $id = sharecode($sc,"decode",true);
    if (!$id) $error = "Unsufficient data provided";
    else {
      if (is_dir($upload_dir_prefix . "share/$id")) {
        xrmdir($upload_dir_prefix . "share/$id");
        $success = "The image was removed successfully.";
      } else {
        $error = "Image not found";
      }
    }
    if (!$in_site) echo ($error?$error:"OK");
  }
}
?>