<?php
  //tidyup the file-names
  function tidyup($str) {
    $str = trim($str);
    $find = array(" ","","","","","","","",",");
    $repl = array("","ae","oe","ue","Ae","Oe","Ue","ss","");
    $str = str_replace($find,$repl,$str);
    $str = preg_replace('([^a-zA-Z0-9\.\-_])', '', $str);
    return $str;
  }
  
  //remove directories recursively
  function xrmdir($location){
   $rc=0;
   if (is_dir($location)){
      $dp=opendir("$location");
      while(false !== ($file = readdir($dp))){
         if ($file=="."||$file=="..") continue;
         xrmdir("$location/$file");
      }
      closedir($dp);
      unset($dp);
      $rc=rmdir($location);
      unset($location);
   }
   else{
      $rc=unlink($location);
      unset($location);
   }
   return $rc;
  }
  
  //just for a simple way to encode/decode sharepics
  function sharecode($str,$method="encode",$strong=false) {
    global $scsec;
    $scsec = intval($scsec);
    $chars = array("a","i","x","r","u","p","e","k","m","b");

    if ($strong && $method == "encode") $str *= $scsec;

    $strarr = str_split($str);
    $cnt = count($strarr);
    if ($method == "encode") {
      for($i=0;$i<$cnt;$i++) {
        $output .= $chars[$strarr[$i]];
      }
    }
    if ($method == "decode") {
      $chars = array_flip($chars);
      for($i=0;$i<$cnt;$i++) {
        $output .= $chars[$strarr[$i]];
      }
      if ($strong) $output /= $scsec;
    }
    return $output;
  }
  
  //display correct language key  
  function lang($key) {
    global $lang, $deblang;
    if (array_key_exists($key, $lang)) return $lang[$key];// . " [$key]";
    else {
      $deblang[] = $key;
      return "__" . $key . "__";
    }
  }

  //some messageboxes
  function success($message) {
    return "<div class='success'><img src='images/icons/success.png' alt='' align='top'> $message</div>";
  }
  function alert($message) {
    return "<div class='alert'><img src='images/icons/warning.png' alt='' align='top'> $message</div>";
  }
  function error($messages) {
    return "<div class='error'><img src='images/icons/error.png' alt='' align='top'> " . lang("errors_occured") . ":
      <ul class='b' style='margin-bottom:0px;'><li>" . implode("</li><li>",$messages) . "</ul></div>";
  }
  
  
  if (!function_exists("checkdnsrr")) {
    function checkdnsrr() {
      return true;
    }
  }
  
  //check if domain in emails exists
  function is_email($email) {
    $email = trim($email);
    if (!$email) return false;
    if (!preg_match("!^[\w|\.|\-|_]+@\w[\w|\.|\-]+\.[a-zA-Z]{2,6}$!",$email)) return false;
    else {
      list($user, $host) = explode("@", $email);
      if (checkdnsrr($host, "MX") or checkdnsrr($host, "A")) return true;
      else return false;
    }
  }
  
  function he($str) {
    //short htmlentities checker - converts all quotes
    $str = htmlentities($str, ENT_QUOTES);
    return $str;
  }
  
  //make the filesize nicier
  function fsize($int) {
    $int = intval($int);
    if ($int/1024 < 1024) return round($int/1024,2) . " KB";
    elseif ($int/1024/1024 < 1024) return round($int/1024/1024,2) . " MB";
    else return round($int/1024/1024,2) . " GB";
  }
  
  //delete files after speciefied days (conf.php -> $del_days)
  function cleanUp() {
    global $del_days, $upload_dir_prefix;
    if (!$del_days) return false;    
    
    $dir = $upload_dir_prefix . "share";
    $d = opendir($dir);
    while(false !== ($file = readdir($d))) {
      if (is_numeric($file)) {
        $file = intval($file);
        $ftime = filectime("$dir/$file/s3/");
        if ($del_days && $ftime < (time()-$del_days * 86400) && is_dir($dir)) {
          //delete if older than $del_days days
          xrmdir("$dir/$file");
        }
      }
    }
    closedir($d);  
  }

  /**
 * rotates an image clockwise or counter clockwise,
 * not using built-in imagerotate function 'cause this function 
 * is only avail if PHP is compiled with the bundled version of the GD library.
 * 
 * @param string $src_img - the path to the image to rotate
 * @param string $angle - the rotation angle 
 * 
 * @return nothing but rotates the image
 **/
function image_rotate($src_img, $angle) {
    $src_x = imagesx($src_img);
    $src_y = imagesy($src_img);
    if ($angle == 180) {
        $dest_x = $src_x;
        $dest_y = $src_y;
    } elseif (($angle == 90) || ($angle == 270)) {
        $dest_x = $src_y;
        $dest_y = $src_x;
    } else return $src_img;
    
    $rotate=imagecreatetruecolor($dest_x,$dest_y);
    imagealphablending($rotate, false);
    
    switch ($angle) {
        case 270:
            $dest_x--;
            for ($y = 0; $y < $src_y; $y++) {
              for ($x = 0; $x < $src_x; $x++) {
                imagesetpixel($rotate, $dest_x - $y, $x, imagecolorat($src_img, $x, $y));
              }
            } break;
        case 90:
            $dest_y--;
            for ($y = 0; $y < $src_y; $y++) {
              for ($x = 0; $x < $src_x; $x++) {
                imagesetpixel($rotate, $y, $dest_y - $x, imagecolorat($src_img, $x, $y));
              }
            }
            break;
        case 180:
            $dest_x--; $dest_y--;
            for ($y = 0; $y < $src_y; $y++) {
              for ($x = 0; $x < $src_x; $x++) {
                imagesetpixel($rotate, $dest_x - $x, $dest_y - $y, imagecolorat($src_img, $x, $y));
              }
            }
            break;
    }
    return $rotate;
}
  
?>