<?php
include ("conf.php");
include ("functions.php");

/*** Language File ***/
$lang_file = "lang/$use_lang/share.lang.php";
if (file_exists($lang_file)) {
  include($lang_file);
} else {
  $output = error(array("Language file $lang_file not found"));
  exit($output);  
}


$sc = $_REQUEST["sc"];
$s = intval($_REQUEST["s"]);

$id = sharecode($sc,"decode");
if (!$id) exit("illegal access");

//check image
if (!is_dir($upload_dir_prefix . "share/$id/s3")) exit("Image not found");
$d = opendir($upload_dir_prefix . "share/$id/s3");
while(false !== ($file = readdir($d))){
   if ($file == "." || $file == "..") continue;
   else {
    $imgfilename = $file;
    break;
  }
}
closedir($d);
if (!$imgfilename) exit("Image not found");
$descrfile = $upload_dir_prefix . "share/$id/descr.txt";
if (file_exists($descrfile)) {
  $handle = fopen($descrfile, "r");
  if (filesize($descrfile)) $descr = fread($handle, filesize($descrfile));
  fclose($handle);
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fa" lang="fa">
  <head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8" />

	<link rel="stylesheet" href="css/shared.css" type="text/css" />
	<link rel='stylesheet' href='css/<?php echo $style; ?>.css' type='text/css' />
  
  <title><?php echo $site_name . ($descr ? " - " . htmlentities($descr) : ""); ?></title>

  </head>
  <body id="shared">

<div id='logo'><a href='<?php echo $url; ?>'><img src='images/logo.png' alt='<?php echo $site_name; ?>' /></a></div>

<div class='content'>
<?php

  //check dimensions and size and ...
  $img = $upload_dir_prefix . "share/$id/s3/" . $imgfilename;
  list($w,$h) = getimagesize($img);
  $filesize = fsize(filesize($img));
  $created = filectime($img);

  if ($s == 3) {
    if ($w > "1024") $add2img = "width='1024'";
  }

  echo "<div class='the-image'>" . ($descr ? "<div class='hl'>" . $descr . "</div>" : "") . "
      <a href='" . ($mod_rewrite ? "tn" . $sc . "S" . $s . ".jpg" : "tn.php?user=ShareAccount&amp;id=$sc&amp;s=$s") . "'><img src='" . ($mod_rewrite ? "tn" . $sc . "S" . $s . ".jpg" : "tn.php?user=ShareAccount&amp;id=$sc&amp;s=$s") . "' alt='" . $row->file_name . "' $add2img /></a><br />
      " . lang("descr_filename") . ": " . $imgfilename . " | " . lang("descr_upped") . ": " . date(lang("date_format"),$created) . " | " . lang("descr_dimensions") . ": $w x $h | " . lang("descr_filesize") . ": $filesize
    </div>
    <hr />
    <div class='download'><a href='" . ($mod_rewrite ? "tn" . $sc . "D.jpg" : "tn.php?user=ShareAccount&amp;id=" . $sc . "&amp;download=true") . "'><img src='images/btn_download.png' alt='Download fullsize' /></a></div>";

?>
</div>
  </body>
</html>
